#!/bin/sh
# This shell script is meant to be invoked directly by users; no Makefile
# or other script invokes it.  The purpose of this script to hand-hold
# the user through creating a minimal valid build.conf file (without the
# user having some existing one) to allow the build to proceed.

echo 'Please select the target you wish to build the firmware for:'
echo
echo '1: Closedmoko GTA01/02 GSM modem'
echo '2: Pirelli DP-L10 feature phone'
echo
echo -n 'Please make your selection: '
read userinput

case "$userinput" in
	1)
		TARGET=gtamodem
		;;
	2)
		TARGET=pirelli
		;;
	*)
		echo 'Invalid selection'
		exit 1;
		;;
esac

echo
echo "target $TARGET" > build.conf
echo "build.conf created; you can now run 'make'"
exit 0
